%define name clanlib
%define version	0.4.4
%define release 28mdk
%define prefix %{_prefix}
%define lib_name_orig libclanlib
%define lib_major 0
%define lib_name %{lib_name_orig}%{lib_major}

Name: %{name}
Summary: The ClanLib Game SDK
Version: %{version}
Release: %{release}
Copyright: LGPL
Group: System/Libraries
Source: http://dark.x.dtu.dk/~mbn/clanlib/download/ClanLib-%{version}.tar.bz2
Source1: ClanLib-magick-from-CVS-00-07-28.tar.bz2
Patch0:	clanlib-fix-IM5.patch.bz2
Patch1:	clanlib-fix-magick-flags.patch.bz2
Patch2:	clanlib-add-force-x11.patch.bz2
Patch3: ClanLib-0.4.4-gcc-2.96.patch.bz2
Patch4: ClanLib-display-compilation.patch.bz2
Patch5: ClanLib-dspbusy-nonblock.patch.bz2
Patch6: ClanLib-cast-gcc-fix.patch.bz2
URL: http://clanlib.org/
Packager: Guillaume Cottenceau <gc@mandrakesoft.com>
BuildRoot: %{_tmppath}/%{name}-buildroot
BuildRequires: libhermes-devel >= 1.3.0 zlib-devel libmikmod-devel libpng-devel libMagick-devel >= 5.0.0 Mesa-common-devel XFree86-devel bzip2 libjpeg-devel libtiff-devel XFree86-static-libs libbzip2-devel
BuildConflicts:	OpenPTC-devel
%ifarch %{ix86}
BuildRequires: svgalib-devel
%endif
Obsoletes: ClanLib

%description
The ClanLib Game SDK is a crossplatform game library designed to ease the work
for game developers. The goal is to provide a common interface to classical
game problems (loading graphics eg.), so games can share as much code as
possible. Ideally anyone with small resources should be able to write
commercial quality games.

%package -n %{lib_name}
Summary: Main library for %{name}
Group: System/Libraries

%description -n %{lib_name}
This package contains the library needed to run programs dynamically
linked with %{name}.

%package -n %{lib_name}-devel
Summary: Headers for developing programs that will use %{name}
Group: Development/C++
Requires: %{lib_name} = %{version} %{lib_name}-gl = %{version} %{lib_name}-mikmod = %{version} %{lib_name}-png = %{version} %{lib_name}-magick = %{version}
Provides: %{lib_name_orig}-devel = %{version}-%{release}
Obsoletes: ClanLib-devel clanlib-devel

%description -n %{lib_name}-devel
This package contains the headers that programmers will need to develop
applications which will use %{name}.

%package -n %{lib_name}-gl
Summary: ClanLib OpenGL module
Group: System/Libraries
Requires: %{lib_name} = %{version}
Obsoletes: ClanLib-gl clanlib-gl

%description -n %{lib_name}-gl
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. This package is the OpenGL module (clanGL).

%package -n %{lib_name}-magick
Summary: ClanLib ImageMagick module
Group: System/Libraries
Requires: %{lib_name} = %{version}
Obsoletes: ClanLib-magick clanlib-magick

%description -n %{lib_name}-magick
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. This package is the ImageMagick module
(clanMagick).

%package -n %{lib_name}-mikmod
Summary: ClanLib MikMod module
Group: System/Libraries
Requires: %{lib_name} = %{version}
Obsoletes: ClanLib-mikmod clanlib-mikmod

%description -n %{lib_name}-mikmod
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. This package is the MikMod module (clanMikMod).

%package -n %{lib_name}-png
Summary: ClanLib PNG module
Group: System/Libraries
Requires: %{lib_name} = %{version}
Obsoletes: ClanLib-png clanlib-png

%description -n %{lib_name}-png
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. This package is the PNG module (clanPNG).

%package docs
Summary: ClanLib documentation
Group: System/Libraries
Obsoletes: ClanLib-docs clanlib-docs

%description docs
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. This package contains the documentation.

%prep
%setup -q -a 1 -n ClanLib-%{version}
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p1
%patch4 -p0
%patch5 -p0
%patch6 -p1
# remove nasty no-newline-at-end-of-line, it bothers gcc-2.96
find . -name "*.h"   -exec perl -pi -e '$_.="\n" if eof' {} \;
find . -name "*.cpp" -exec perl -pi -e '$_.="\n" if eof' {} \;

%build
# (gc) workaround g++ exception bug when -fomit-frame-pointer is set
export CFLAGS="$RPM_OPT_FLAGS -fno-omit-frame-pointer" CXXFLAGS="$RPM_OPT_FLAGS -fno-omit-frame-pointer"
autoconf

%ifarch %{ix86}
  %configure --enable-x11 --enable-fbdev --enable-opengl --disable-svgalib --enable-clansound --enable-network --enable-asm386 --enable-dyn
%endif

# (Dadou) GG put some non usuable options in %ifnarch ix86 (like svga)
# configure do a (nearly nice job), so let it plays
%ifarch ppc
	%configure --disable-asm386
%endif

%ifnarch %{ix86} ppc
  %configure --enable-x11 --enable-fbdev --enable-opengl --disable-svgalib --enable-clansound --enable-network --enable-dyn --disable-asm386
%endif

make clanCore
make clanGL
make clanMikMod
make clanMagick
#make clanGUI
#make clanLua
#make clanMPEG
make clanPNG
make strip
make docs

%install
%makeinstall BIN_PREFIX=$RPM_BUILD_ROOT%{_bindir} LIB_PREFIX=$RPM_BUILD_ROOT%{_libdir} INC_PREFIX=$RPM_BUILD_ROOT%{_includedir} TARGET_PREFIX=$RPM_BUILD_ROOT%{_libdir}/ClanLib
make MAN_PREFIX=$RPM_BUILD_ROOT%{_mandir} HTML_PREFIX=$RPM_BUILD_ROOT%{_datadir}/doc/%{name}-docs-%{version}/Docs docs_install

mkdir -p $RPM_BUILD_ROOT/%{_bindir}
cat << EOF > $RPM_BUILD_ROOT/%{_bindir}/launch_x11_clanapp
#!/bin/sh
[ -x \$1 ] && CLANLIB_FORCE_X11_DISPLAY=1 \$1
EOF

%post -n %{lib_name} -p /sbin/ldconfig
%post -n %{lib_name}-gl -p /sbin/ldconfig
%post -n %{lib_name}-mikmod -p /sbin/ldconfig
%post -n %{lib_name}-png -p /sbin/ldconfig
%post -n %{lib_name}-magick -p /sbin/ldconfig

%postun -n %{lib_name} -p /sbin/ldconfig
%postun	-n %{lib_name}-gl -p /sbin/ldconfig
%postun	-n %{lib_name}-mikmod -p /sbin/ldconfig
%postun	-n %{lib_name}-png -p /sbin/ldconfig
%postun -n %{lib_name}-magick -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc README
%attr(0755,root,root) %{_bindir}/launch_x11_clanapp

%files -n %{lib_name}
%defattr(-, root, root)
%doc README COPYING CREDITS
%{_libdir}/libclanCore.so.*
%{_libdir}/ClanLib

%files -n %{lib_name}-devel
%defattr(-, root, root)
%doc README COPYING CODING_STYLE FAQ ascii-logo
%{_libdir}/*.so
%{_includedir}/ClanLib/*
%{_bindir}/clanlib-config

%files docs
%defattr(-, root, root)
%{_docdir}/%{name}-docs-%{version}/*
%{_mandir}/man1/datafile_compiler.1*
%{_mandir}/man3/CL*
%{_mandir}/man3/clanlib.3*

%files -n %{lib_name}-gl
%defattr(-, root, root)
%doc README COPYING 
%{_libdir}/libclanGL.so.*

%files -n %{lib_name}-magick
%defattr(-, root, root)
%doc README COPYING 
%{_libdir}/libclanMagick.so.*

%files -n %{lib_name}-mikmod
%defattr(-, root, root)
%doc README COPYING 
%{_libdir}/libclanMikMod.so.*

%files -n %{lib_name}-png
%defattr(-, root, root)
%doc README COPYING 
%{_libdir}/libclanPNG.so.*

#%files lua
#%defattr(-, root, root)
#%{prefix}/lib/libclanLua.so*

#%files gui
#%defattr(-, root, root)
#%{prefix}/lib/libclanGUI.so*

#%files mpeg
#%defattr(-, root, root)
#%{prefix}/lib/libclanMPEG.so*

%changelog
* Tue Aug  7 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-28mdk
- devel package needs all library packages, thanks to yves

* Mon Jul 23 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-27mdk
- build-needs libMagick-devel rather than ImageMagick-devel, thanks to gb

* Sat Jun 23 2001 Jeff Garzik <jgarzik@mandrakesoft.com> 0.4.4-26mdk
- add cast, to fix build with gcc-2.96 on alpha

* Thu Apr 12 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-25mdk
- don't block forever on a busy dsp (patch #5)

* Fri Mar 30 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-24mdk
- use no-omit-frame-pointer to workaround g++ exceptions bug

* Thu Mar 22 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-23mdk
- remove explicit requires on requires, silly me

* Fri Mar  9 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-22mdk
- recompile without svgalib

* Fri Feb 16 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-21mdk
- do not put the launch_x11_clanapp script in the lib package!
- provides devel-lib with version
- put subpackages' devel files in generic devel package

* Mon Feb 12 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-20mdk
- fix BuildRequires (libbzip2-devel, thx to Jeff)

* Fri Dec  8 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-19mdk
- fix BuildRequires

* Tue Nov 28 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-18mdk
- new lib policy

* Tue Nov  7 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-17mdk
- provides ClanLib for compatibility

* Fri Nov  3 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-16mdk
- rebuild to have correct deps (e.g. sucking libraries linked to themselves)
- change name to clanlib (e.g. uppercase names suck)
- rebuild against lowercased hermes

* Fri Nov  3 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-15mdk
- really recompile against newest libstdc++

* Fri Nov  3 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-14mdk
- recompile against newest libstdc++

* Mon Oct 16 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-13mdk
- fix no-newline-at-end-of-some-sourcefiles that bothers gcc-2.96

* Mon Oct 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.4.4-12mdk
- Fix gcc2.96 compilation;

* Sun Sep 17 2000 David BAUDENS <baudens@mandrakesoft.com> 0.4.4-11mdk
- Don't use i386 code on non i386 compatibles archs
- Let configure do is job on PPC (and really don't use i386 code)

* Fri Sep 15 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-10mdk
- rebuild against fixed XFree-4 by fredl

* Fri Sep  8 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-9mdk
- fixed BuildRequires: removed ClanLib-devel, added XFree86-static-libs,
  ImageMagick >= 5.0.0
- removed nasty static -march=pentium, /me sucks

* Wed Sep  6 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-8mdk
- added the optional force of x11 target (envvar CLANLIB_FORCE_X11_DISPLAY)
- added a script to launch clanlib apps with force x11 target

* Wed Aug 30 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-7mdk
- added more documentation in subpackages

* Wed Aug 23 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-6mdk
- automatically added packager tag

* Wed Aug 23 2000 Frederic Lepied <flepied@mandrakesoft.com> 0.4.4-5mdk
- corrected BuildRequires for archs other than ix86.

* Tue Aug 08 2000 Frederic Lepied <flepied@mandrakesoft.com> 0.4.4-4mdk
- automatically added BuildRequires

* Tue Aug  1 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-3mdk
- not 100% sure with the 2mdk

* Mon Jul 31 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-2mdk
- integrated patch to ImageMagick stuff from the clanlib-devel mailing
  list, thanks to the help of Ingo Ruhnke <grumbel@gmx.de>; it was a
  contribution from Matt Kimball <mkimball@veriomail.com>

* Mon Jul 31 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.4.4-1mdk
- took SRPM from ClanLib web site
- Mandrake adaptations
- ugly: take the Magick stuff from CVS to compile with ImageMagick 5
- mega headache; had to redefine CXXFLAGS to remove -mcpu=pentiumpro
